/*Programa de prueba para el selector de monedas
Inicialmente el programa detecta si el conector de monedas
se encuentra correctamente alimentado con 12 volts y 
las seales COIN y GND conectadas al puerto del sistema Bolt.
y muestra "FALLA" en el LCD en caso de estar desconectado. 
Una vez conectado correctamente, solicita al usuario
una opcin 0=mirinda, 1=pepsi. Para avanzar, el usuario
debe oprimir cualquier tecla. El sistema solicita depositar
una cantidad y posteriormente el usuario inserta las
monedas necesarias de 2 pesos. Cuando la cuenta llega a 0
pesos, se enciende el relevador para activar la entrega
del refresco solicitado. El selector debe ajustarse con 
monedas de 2 pesos. El switch SW1 debe estar en estado OFF.
*/

#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
char wo[7];
unsigned char boton;
int mir,jar,i;
char mi[]="MIRINDA";
char falla[]="FALLA";
char conok[]="CON OK!";
char ja[]="PEPSI";
char opcion[]="OPCION:"; 
char listo[]="LISTO!";
char deposite[]="DEPOSITE";	

void main(void)
{
init_bolt();
InitLCD();
malla:
RELE=0;
if(SW1==1)
{
ClearScreen();
PrintString(falla);				//falla la conexin de selector de monedas
delay_ms(100);
goto malla;						
}						
if(SW1==0)
{
ClearScreen();
PrintString(conok);	//selector de monedas conectado
delay_ms(2000);
}
ClearScreen();
PrintString(opcion);
boton=GetBot();
ClearScreen();
PutLCD(boton);
GotoXY(1,0);
if(boton=='0')
		{
		mir=10;
		PrintString(mi);
		boton=GetBot();
		ClearScreen();
		PrintString(mi);
		GotoXY(1,0);
		sprintf(wo," $%2d",mir);
		PrintString(wo);
		boton=GetBot();
		ClearScreen();
		PrintString(deposite);
		GotoXY(1,0);
		sprintf(wo," $%2d",mir);
		PrintString(wo);
		loop:
		if(SW1==1)
			{
			mir=mir-2;
			if(mir==0)
				{
				ClearScreen();
				PrintString(listo);
				RELE=1;					//activa actuador para entrega de lata
				delay_ms(4000);
				goto malla;
				}
			GotoXY(1,0);
			sprintf(wo," $%2d",mir);
			PrintString(wo);
			delay_ms(2000);
			}
		goto loop;
		}
if(boton=='1')
		{
		jar=8;
		PrintString(ja);
		boton=GetBot();
		ClearScreen();
		PrintString(ja);
		GotoXY(1,0);
		sprintf(wo," $%2d",jar);
		PrintString(wo);
		boton=GetBot();
		ClearScreen();
		PrintString(deposite);
		GotoXY(1,0);
		sprintf(wo," $%2d",jar);
		PrintString(wo);
		loop1:
		if(SW1==1)
			{
			jar=jar-2;
			if(jar==0)
				{
				ClearScreen();
				PrintString(listo);
				RELE=1;					//activa actuador para entrega de lata
				delay_ms(4000);
				goto malla;
				}
			GotoXY(1,0);
			sprintf(wo," $%2d",jar);
			PrintString(wo);
			delay_ms(2000);
			}
		goto loop1;
		}

goto malla;
} 







